// bluehost7Dlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "bluehost7.h"
#include "bluehost7Dlg.h"

#include "sal.h"
#include <setupapi.h>
#include "Winusb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MY_DEVICE_ID  "Vid_0a12&Pid_0001"


//  Variables that need to have wide scope.
	HANDLE MyDeviceHandle = INVALID_HANDLE_VALUE;		//First need to get the Device handle
	WINUSB_INTERFACE_HANDLE MyWinUSBInterfaceHandle;	//And then can call WinUsb_Initialize() to get the interface handle
														//which is needed for doing other operations with the device (like
														//reading and writing to the USB device).
/////////////////////////////////////////////////////////////////////////////
// CBluehost7Dlg _CAO

CBluehost7Dlg::CBluehost7Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBluehost7Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBluehost7Dlg)
		// : ̈ʒu ClassWizard ɂăȍǉ܂B
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBluehost7Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBluehost7Dlg)
		// : ̏ꏊɂ ClassWizard ɂ DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBluehost7Dlg, CDialog)
	//{{AFX_MSG_MAP(CBluehost7Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEND, OnSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBluehost7Dlg bZ[W nh

BOOL CBluehost7Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	Init();
	InitBlue();
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CBluehost7Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CBluehost7Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBluehost7Dlg::Init()
{

//-------------------------------------------------------BEGIN CUT AND PASTE BLOCK-----------------------------------------------------------------------------------
		/* 
		Before we can "connect" our application to our USB embedded device, we must first find the device.
		A USB bus can have many devices simultaneously connected, so somehow we have to find our device, and only
		our device.  This is done with the Vendor ID (VID) and Product ID (PID).  Each USB product line should have
		a unique combination of VID and PID.  

		Microsoft has created a number of functions which are useful for finding plug and play devices.  Documentation
		for each function used can be found in the MSDN library.  We will be using the following functions:

		SetupDiGetClassDevs()					//provided by setupapi.dll, which comes with Windows
		SetupDiEnumDeviceInterfaces()			//provided by setupapi.dll, which comes with Windows
		GetLastError()							//provided by kernel32.dll, which comes with Windows
		SetupDiDestroyDeviceInfoList()			//provided by setupapi.dll, which comes with Windows
		SetupDiGetDeviceInterfaceDetail()		//provided by setupapi.dll, which comes with Windows
		SetupDiGetDeviceRegistryProperty()		//provided by setupapi.dll, which comes with Windows
		malloc()								//part of C runtime library, msvcrt.dll?
		CreateFile()							//provided by kernel32.dll, which comes with Windows

		We will also be using the following unusual data types and structures.  Documentation can also be found in
		the MSDN library:

		PSP_DEVICE_INTERFACE_DATA
		PSP_DEVICE_INTERFACE_DETAIL_DATA
		SP_DEVINFO_DATA
		HDEVINFO
		HANDLE
		GUID

		The ultimate objective of the following code is to call WinUsb_Initialize(), which gets an interface handle
		to a specific interface on a USB device.  This handle will be needed later when calling WinUsb_WritePipe()
		and WinUsb_ReadPipe().  These functions are used to actually send and receive application related data 
		to/from the USB peripheral device.

		However, in order to call WinUsb_Initialize(), we first need to get the device path for the USB device
		with the correct VID and PID.  Getting the device path is a multi-step round about process, which
		requires calling several of the SetupDixxx() functions provided by setupapi.dll.
		*/


		//Globally Unique Identifier (GUID). Windows uses GUIDs to identify things.  This GUID needs to match
		//the GUID that is used in the .INF file used to install the WinUSB driver onto the system.
		//The INF file creates a register entry which associates a GUID with the WinUSB device.  In order for
		//a user mode application (such as this one) to find the USB device on the bus, it needs to known the
		//correct GUID that got put into the registry.
		GUID InterfaceClassGuid = {0x58D07210, 0x27C1, 0x11DD, 0xBD, 0x0B, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66}; 

		HDEVINFO DeviceInfoTable = INVALID_HANDLE_VALUE;
		PSP_DEVICE_INTERFACE_DATA InterfaceDataStructure = new SP_DEVICE_INTERFACE_DATA;
		PSP_DEVICE_INTERFACE_DETAIL_DATA DetailedInterfaceDataStructure = new SP_DEVICE_INTERFACE_DETAIL_DATA;
		SP_DEVINFO_DATA DevInfoData;

		DWORD InterfaceIndex = 0;
		DWORD StatusLastError = 0;
		DWORD dwRegType;
		DWORD dwRegSize;
		DWORD StructureSize = 0;
		PBYTE PropertyValueBuffer;
		bool MatchFound = false;
		DWORD ErrorStatus;
		BOOL BoolStatus = FALSE;

		CString DeviceIDToFind = MY_DEVICE_ID;


		//First populate a list of plugged in devices (by specifying "DIGCF_PRESENT"), which are of the specified class GUID. 
		DeviceInfoTable = SetupDiGetClassDevs(&InterfaceClassGuid, NULL, NULL, DIGCF_PRESENT | DIGCF_DEVICEINTERFACE);

		//Now look through the list we just populated.  We are trying to see if any of them match our device. 
		while(true)
		{
			InterfaceDataStructure->cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);
			if(SetupDiEnumDeviceInterfaces(DeviceInfoTable, NULL, &InterfaceClassGuid, InterfaceIndex, InterfaceDataStructure))
			{
				ErrorStatus = GetLastError();
				if(ERROR_NO_MORE_ITEMS == ErrorStatus)	//Did we reach the end of the list of matching devices in the DeviceInfoTable?
				{	//Cound not find the device.  Must not have been attached.
					SetupDiDestroyDeviceInfoList(DeviceInfoTable);	//Clean up the old structure we no longer need.
					return;		
				}
			}
			else	//Else some other kind of unknown error ocurred...
			{
				ErrorStatus = GetLastError();
				SetupDiDestroyDeviceInfoList(DeviceInfoTable);	//Clean up the old structure we no longer need.
				return;	
			}


			//Now retrieve the hardware ID from the registry.  The hardware ID contains the VID and PID, which we will then 
			//check to see if it is the correct device or not.

			//Initialize an appropriate SP_DEVINFO_DATA structure.  We need this structure for SetupDiGetDeviceRegistryProperty().
			DevInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
			SetupDiEnumDeviceInfo(DeviceInfoTable, InterfaceIndex, &DevInfoData);

			//First query for the size of the hardware ID, so we can know how big a buffer to allocate for the data.
			SetupDiGetDeviceRegistryProperty(DeviceInfoTable, &DevInfoData, SPDRP_HARDWAREID, &dwRegType, NULL, 0, &dwRegSize);

			//Allocate a buffer for the hardware ID.
			PropertyValueBuffer = (BYTE *) malloc (dwRegSize);
			if(PropertyValueBuffer == NULL)	//if null, error, couldn't allocate enough memory
			{	//Can't really recover from this situation, just exit instead.
				SetupDiDestroyDeviceInfoList(DeviceInfoTable);	//Clean up the old structure we no longer need.
				return;		
			}

			//Retrieve the hardware IDs for the current device we are looking at.  PropertyValueBuffer gets filled with a 
			//REG_MULTI_SZ (array of null terminated strings).  To find a device, we only care about the very first string in the
			//buffer, which will be the "device ID".  The device ID is a string which contains the VID and PID, in the example 
			//format "Vid_04d8&Pid_003f".
			SetupDiGetDeviceRegistryProperty(DeviceInfoTable, &DevInfoData, SPDRP_HARDWAREID, &dwRegType, PropertyValueBuffer, dwRegSize, NULL);

			//Now check if the first string in the hardware ID matches the device ID of my USB device.
			#ifdef UNICODE
			CString DeviceIDFromRegistry = (wchar_t *)PropertyValueBuffer;
			#else
			CString DeviceIDFromRegistry = (char *)PropertyValueBuffer;
			#endif

			free(PropertyValueBuffer);		//No longer need the PropertyValueBuffer, free the memory to prevent potential memory leaks

			//Convert both strings to lower case.  This makes the code more robust/portable accross OS Versions
			DeviceIDFromRegistry.MakeLower();
//				->ToLowerInvariant();	
			DeviceIDToFind.MakeLower();				
			//Now check if the hardware ID we are looking at contains the correct VID/PID
//			MatchFound = DeviceIDFromRegistry->Contains(DeviceIDToFind);		
//			if(MatchFound == true)
			if(-1!=DeviceIDFromRegistry.Find(DeviceIDToFind))	
			{
				//Device must have been found.  Open WinUSB interface handle now.  In order to do this, we will need the actual device path first.
				//We can get the path by calling SetupDiGetDeviceInterfaceDetail(), however, we have to call this function twice:  The first
				//time to get the size of the required structure/buffer to hold the detailed interface data, then a second time to actually 
				//get the structure (after we have allocated enough memory for the structure.)
				DetailedInterfaceDataStructure->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
				//First call populates "StructureSize" with the correct value
				SetupDiGetDeviceInterfaceDetail(DeviceInfoTable, InterfaceDataStructure, NULL, NULL, &StructureSize, NULL);	
				DetailedInterfaceDataStructure = (PSP_DEVICE_INTERFACE_DETAIL_DATA)(malloc(StructureSize));		//Allocate enough memory
				if(DetailedInterfaceDataStructure == NULL)	//if null, error, couldn't allocate enough memory
				{	//Can't really recover from this situation, just exit instead.
					SetupDiDestroyDeviceInfoList(DeviceInfoTable);	//Clean up the old structure we no longer need.
					return;		
				}
				DetailedInterfaceDataStructure->cbSize = sizeof(SP_DEVICE_INTERFACE_DETAIL_DATA);
				 //Now call SetupDiGetDeviceInterfaceDetail() a second time to receive the goods.  
				SetupDiGetDeviceInterfaceDetail(DeviceInfoTable, InterfaceDataStructure, DetailedInterfaceDataStructure, StructureSize, NULL, NULL); 

				//We now have the proper device path, and we can finally open a device handle to the device.
				//WinUSB requires the device handle to be opened with the FILE_FLAG_OVERLAPPED attribute.
				MyDeviceHandle = CreateFile((DetailedInterfaceDataStructure->DevicePath), GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);

				ErrorStatus = GetLastError();
				if(ErrorStatus == ERROR_SUCCESS)
				{
					//Now get the WinUSB interface handle by calling WinUsb_Initialize() and providing the device handle.
					BoolStatus = WinUsb_Initialize(MyDeviceHandle, &MyWinUSBInterfaceHandle);				
					if(BoolStatus == TRUE)
					{
						//If gets here, the "MyWinUSBInterfaceHandle" was initialized successfully.
						//May begin using the MyWinUSBInterfaceHandle handle in WinUsb_WritePipe() and
						//the USB device's endpoints.

//						ToggleLED_btn->Enabled = true;				//Make button no longer greyed out
//						GetPushbuttonState_btn->Enabled = true;		//Make button no longer greyed out
//						StateLabel->Enabled = true;					//Make label no longer greyed out

					}
				}

				SetupDiDestroyDeviceInfoList(DeviceInfoTable);	//Clean up the old structure we no longer need.
				return;
			}

			InterfaceIndex++;	
			//Keep looping until we either find a device with matching VID and PID, or until we run out of items.
		}//end of while(true)	
//-------------------------------------------------------END CUT AND PASTE BLOCK-------------------------------------------------------------------------------------

}

void CBluehost7Dlg::OnSend() 
{
	ULONG BytesWritten = 0;
	ULONG BytesRead = 0;
	unsigned char dummy[32];
	int i,j;

	GetDlgItemText( IDC_WRITE, (char *)(OutputPacketBuffer+8),40);//őf[^40oCgƂĂB

	//ACL header
	OutputPacketBuffer[0]=blue_handle[0];// connection handle+ PB flag + BC flag
	OutputPacketBuffer[1]=blue_handle[1];// 5.4.2 HCI ACL Data Packets of Core v2.0 + EDR.pdfB
	OutputPacketBuffer[2]=0x36; //f[^{S
	OutputPacketBuffer[3]=0x00; //0x0024̃gGfBA: 0x240x00
	OutputPacketBuffer[4]=0x32;//f[^igGfBAj
	OutputPacketBuffer[5]=0x00;
	OutputPacketBuffer[6]=0x40;//ɂ͖{`lhc^̂AHCI[ł
	OutputPacketBuffer[7]=0x00;//0x0040igGfBAjȏ̐^ĂΗǂA

	//ohbփf[^𑗐M
	WinUsb_WritePipe(MyWinUSBInterfaceHandle, 0x02, &OutputPacketBuffer[0], 58, &BytesWritten, NULL);  
	//ohbf[^M
	WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x82, &InputPacketBuffer[0], 58, &BytesRead, NULL);  

	SetDlgItemText( IDC_READ, (char *)(InputPacketBuffer+8));
	
	//obɕtĂhÕCxgbZ[Wǂ
	do {
			WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(BytesRead!=0);
}

void CBluehost7Dlg::InitBlue(void)
{
	ULONG BytesWritten = 0;
	ULONG BytesRead = 0;
	int i;

	//Reset the PC dongle (use ClassRequest for HCI commands)
	OutputPacketBuffer[0]=0x03;
	OutputPacketBuffer[1]=0x0C;
	OutputPacketBuffer[2]=0x00;
	My_ClassRequest(OutputPacketBuffer,3);

	do{//responses for HCI commands are returned as HCI events to Endpoint 1(81)
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x0e);

	//Read bd_address of the PC dongle
	OutputPacketBuffer[0]=0x09;
	OutputPacketBuffer[1]=0x10;
	OutputPacketBuffer[2]=0x00;
	My_ClassRequest(OutputPacketBuffer,3);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x0e);


	//Set name for the PC dongle
	OutputPacketBuffer[0]=0x13;
	OutputPacketBuffer[1]=0x0c;
	OutputPacketBuffer[2]=0x04;
	OutputPacketBuffer[3]='Y';
	OutputPacketBuffer[4]='T';
	OutputPacketBuffer[5]='S';
	OutputPacketBuffer[6]=0x00;
	My_ClassRequest(OutputPacketBuffer,7);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x0e);

	//Write Scan Enable Command (the PC dongle can be scanned by any other bluethooth devises)
	OutputPacketBuffer[0]=0x1a;
	OutputPacketBuffer[1]=0x0c;
	OutputPacketBuffer[2]=0x01;
	OutputPacketBuffer[3]=0x03;
	My_ClassRequest(OutputPacketBuffer,4);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x0e);

	//Inquiry (search any other bluetooth dongles around you)
	OutputPacketBuffer[0]=0x01;
	OutputPacketBuffer[1]=0x04;
	OutputPacketBuffer[2]=0x05;
	OutputPacketBuffer[3]=0x33;
	OutputPacketBuffer[4]=0x8b;
	OutputPacketBuffer[5]=0x9e;
	OutputPacketBuffer[6]=0x05;//waiting time (5 * 1.28 sec)
	OutputPacketBuffer[7]=0x01;//if there are bluetooth devices around you, you should give a maximum number here. 
	My_ClassRequest(OutputPacketBuffer,8);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
		if(InputPacketBuffer[0]==0x01 && InputPacketBuffer[0]!=0x00) {// if errors
			MessageBox("Inquiry Failed. Retry",NULL,MB_OK);
			EndDialog(1);
			return;
		}
		
	}while(InputPacketBuffer[0]!=0x02);

	unsigned char PIC_address[6];
	for(i=0;i<6;i++) PIC_address[i]=InputPacketBuffer[3+i];

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x01);

	OutputPacketBuffer[0]=0x05;
	OutputPacketBuffer[1]=0x04;
	OutputPacketBuffer[2]=0x0d;
	for(i=0;i<6;i++) OutputPacketBuffer[3+i]=PIC_address[i];
	OutputPacketBuffer[9]=0x10;//0x0010 DH1
	OutputPacketBuffer[10]=0x00;
	OutputPacketBuffer[11]=0x00;
	OutputPacketBuffer[12]=0x00;
	OutputPacketBuffer[13]=InputPacketBuffer[15];//copy clock offset
	OutputPacketBuffer[14]=InputPacketBuffer[16];//
	OutputPacketBuffer[15]=0x00;
	My_ClassRequest(OutputPacketBuffer,16);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x03);


	if(InputPacketBuffer[2]!=0) {// if error
		MessageBox("Connection Failed. Retry",NULL,MB_OK);
		EndDialog(1);
		return;
	}

	//save connection handle and add (PB flag + BC flag)
	blue_handle[0]=InputPacketBuffer[3];blue_handle[1]=InputPacketBuffer[4]|0x20;

	//Write Scan Enable Command 
	OutputPacketBuffer[0]=0x1a;
	OutputPacketBuffer[1]=0x0c;
	OutputPacketBuffer[2]=0x01;
	OutputPacketBuffer[3]=0x00;//Disable

	My_ClassRequest(OutputPacketBuffer,4);

	do{
		WinUsb_ReadPipe(MyWinUSBInterfaceHandle, 0x81, &InputPacketBuffer[0], 64, &BytesRead, NULL);  
	}while(InputPacketBuffer[0]!=0x0e);

	//obɕtĂhÕCxgbZ[Wǂފ֐ɑ΂^CAEgݒ
	ULONG timeout;
	timeout = 10;
	WinUsb_SetPipePolicy(MyWinUSBInterfaceHandle, 0x81, PIPE_TRANSFER_TIMEOUT, sizeof(ULONG), &timeout); 

}

void CBluehost7Dlg::My_ClassRequest(unsigned char *buf,int len)
{
	WINUSB_SETUP_PACKET setupPacket;
	ULONG bytesReturned;
	BOOL bResult;

	setupPacket.RequestType = 0x21; //Class Request (Host to Device)
	setupPacket.Request = 0;
	setupPacket.Value = 0;
	setupPacket.Index = 0;
	setupPacket.Length = len;//data length
 
	bResult = WinUsb_ControlTransfer(MyWinUSBInterfaceHandle, setupPacket, buf, 
			len, &bytesReturned, NULL);
}

void CBluehost7Dlg::OnOK() 
{
}
